; Joe Wingbermuehle's TI-83 Include File
; 06-10-1998

;-----> SOS custom stuff
; This routine is only availiable while SOS is running... duh
sos_swap	=$9171	; swap byte (hl) with (de), dec bc and compare it to zero

op1_to_op2	=$418E	; op2=op1
op1_to_op3	=$417E
op1_to_op4	=$416E
op1_to_op5	=$41BE
op1_to_op6	=$41BA
op2_to_op1	=$41C2
op2_to_op3	=$41F6
op2_to_op4	=$4172
op2_to_op5	=$41B2
op2_to_op6	=$41B6
op3_to_op1	=$41A2
op3_to_op2	=$417A
op3_to_op4	=$416A
op3_to_op5	=$41AE
op4_to_op1	=$419A
op4_to_op2	=$4176
op4_to_op3	=$41FA
op4_to_op5	=$41AA
op4_to_op6	=$4202
op5_to_op1	=$419E
op5_to_op2	=$4182
op5_to_op3	=$41FE
op5_to_op4	=$418A
op5_to_op6	=$4186
op6_to_op1	=$4196
op6_to_op2	=$4192
op6_to_op5	=$41A6

op1_ex_op2	=$4306	; exchange op1 and op2
op1_ex_op3	=$42FE
op1_ex_op4	=$4302
op1_ex_op5	=$42EE
op1_ex_op6	=$42F2
op2_ex_op4	=$42F6
op2_ex_op5	=$42FA
op2_ex_op6	=$42E6
op5_ex_op6	=$42EA

op1set0		=$4286	; op1=0
op1set1		=$4232
op1set2		=$4242
op1set3		=$423A
op1set4		=$4236
op2set0		=$4282
op2set1		=$4252
op2set2		=$4246
op2set3		=$422E
op2set4		=$422A
op2set5		=$4222
op2set8		=$421E
op2set60	=$4EA8
op2setA		=$4226	; op2="A" ?
op3set0		=$427E
op3set1		=$421A
op3set2		=$423E
op4set0		=$427A
op4set1		=$4216
op5set0		=$4276

push_op1	=$454A	; push op1
push_op3	=$4542

pop_op1		=$44E6	; pop op1
pop_op3		=$44E2

setxxop1	=$4A74	; op1=a
setxxop2	=$4A78	; op2=a
setxxxxop2	=$4A7C	; op2=hl
zeroop1		=$428E	; op1=$00 00 00 00 00...
rclx		=$4EE8	; op1=X
stox		=$4ED4	; X=op1
cpop1op2	=$4166	; compare op1 and op2


;-----> Large font (all writes take place at (currow,curcol) & update)

homeup		=$4775	; set (currow,curcol) to (0,0)
moveup		=$474D	; move cursor up a line, scroll if necessary
movedown	=$4741	; move cursor down a line, scroll if necessary
newline		=$473D	; same as move down, but sets curcol to 0
scrollup	=$4745	; scroll screen up one line
scrolldown	=$4751	; scroll screen down one line
erase_eol	=$476D	; erases text from current cursor to end of line

putps		=$4715	; write a string, post length (in: hl->string)
putsm		=$4C33	; ?
putmap		=$4701	; write a character, do not update cursor (in: a=character)
put_ans		=$51CB	; write value stored in Ans var?
putbuf1		=$4721	; ?
disphl		=$4709	; display value in hl
disp_done	=$47F1	; display "Done"

vputs		=$4781	; write 0 terminated string (in: hl->string)
vputsn		=$4785	; write string, b=length (in: hl->string)
vputblank	=$4C53	; write a space
dispop1a	=$51D4	; display op1 with length a

;-----> General gfx
rindoff		=$4795	; turn off run indicator
rindon		=$4791	; turn on run indicator
clrscr		=$4755	; clear screen
clrwin		=$4769	; clear window, similar to clrscr ??
clrshd		=$4765	; clear text shadow
clrgbuf		=$515B	; clear graph buffer
bufcopy		=$5164	; copy graph buffer to display
gbuf		=$8E29	; graph buffer
axes		=$519E	; draw axes

ipoint		=$4AE8	; plot pixel at (b,c) h={0=off,1=on,2=xor,3=tst} (TI's coordinates)
iline		=$4AE4	; draw line (b,c)-(d,e) h={0=off,1=on,2=xor} (TI's coordinates)
dark_line	=$4AE0	; same as iline with h=1
vert_cmd	=$4BF3	; draw line op1, uses graph coordinates
horz_cmd	=$4BEF	; draw line op1, uses graph coordinates
dispg		=$4BEB	; display graph, redraws if dirty
lcdbusy		=$4066	; short pause for display, use if out/in-ing with display
; Standard coordinates: top left corner=(0,0); bottom right corner=(95,63)
; TI's coordinates: top left corner=(0,63); bottom right corner=(95,0)
; Graph coordinates: depends on window settings

;-----> LCD
lcd_inst_port	=$10
lcd_data_port	=$11

x_start		=$80	;\ 64 lines total \  The upper and lower limits
x_stop		=$BF	;/		   \ for setting the position on
y_start		=$20	;\ 12 bytes	   / the LCD
y_stop		=$2B	;/ total per line /  out them as instructions (any position)

x_inc_mode	=$05	; increase x position with every write (MUST set back to this mode!)
y_inc_mode	=$07	; increase y position with every write
set_first_x	=$20	; move to first x position
set_first_y	=$80	; move to first y position
; The above instructions are sent the the instruction port ($10).
; Data is written 8 pixels at a time through a byte sent/read to/from the data port ($11).
; Dummy read must take place before a real read after setting coordinates.
; di before writing to these ports!

;-----> Keyboard
getk		=$4A18	; get key, do not wait, a=scancode, op1=keycode
keyport		=$01	; port for communicating directly with the keyboard

;-----> Utility
htimesl		=$4382	; hl=h*l
divhlbya	=$400C	; hl=hl/a
ldhlind		=$4000	; h=(hl+1), l=(hl)
cphlde		=$4004	; compare hl and de

auto_power_down	=$018E	; shut down calc, reset port 3 1st! apd buffer=destroyed

;-----> Memory
chksysvar	=$442A	; find a variable in op1 (op1=type,op1+1 to ...=name)
createprog	=$448A	; create program with type/name in op1 with hl bytes
delvar		=$44AA	; delete a variable, use chksysvar 1st
insertmem	=$4432	; insert hl bytes from de to $9327
memfree		=$441A	; hl=free mem
fat		=$9319	; aka vat, points to the end of symbol table
sym_table	=$FE6E	; end of the symbol table/vat/fat (stack begins next byte)
usermemoff	=$8565	; user memory offset, points to end of used memory ?

;-----> Safe RAM areas
sram		=$8265	; APD RAM (saves screem of calc apds), 768 bytes
cmdshad		=$9157	; command shadow (saves home screen), 128 bytes (do NOT from SOS!)
textshad	=$80C9	; text shadow (backup of text screen), 128 bytes

;-----> Error handlers
errundef	=$467B	; display "ERROR:UNDEF" msg & exit
errmem		=$464E	; "ERROR:MEM" and exit

